<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/orderby.php";

include_once "include/site.php";
;

$album_id = pg_escape_string($_REQUEST['album']);
$offset = pg_escape_string(isset($_REQUEST['offset']) ? $_REQUEST['offset'] : 0);

$database   = site_prolog();
$order_by = $po_options['order_by'];

if ($album_id) {
  $album = pg_fetch_row(pg_query($database, "select caption, access_rights, users, description, users.type, album.password, can_access_album(album.identifier, $po_user[id], '{".$passwords."}')  from album, users where album.identifier=$album_id and users.identifier = album.users"));
}

if (!$album) {
  header("HTTP/1.1 404 Not found");
  site_header($strings['generic']['display_album']);
  site_navigator(5);
  site_navigator_status(user_disp_string(0, $po_user['id'], "", ""). " : ". $strings['errors']['no_such_album'], "");
  site_footer($database);
  site_epilog($database);
  exit();
}

if ($album[6] == 'f') {
  if ($album[1] == $access['private']) {
    header("HTTP/1.1 403 Forbidden");
    site_header($strings['generic']['display_album']);
    site_navigator(1);
    site_navigator_status(user_disp_string(0, $po_user['id'], "", ""). " : ". $strings['errors']['private'], "");
    site_footer($database);
    site_epilog($database);
  } else {
    site_push_error($strings['errors']['protected']);
    header("Location: login.php?reason=protected&orig=".urlencode("album.php?album=$album_id"));
  }
  exit();
 }

/* get the last value from the database */
$album_name = $album[0];
$owner_id   = $album[2];

$sql_query_order_by_string = $order_by_string[$order_by][0];

$sql_query_access_rights_string = "and can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}')";

$user_data = pg_fetch_row(pg_query($database, "
   select last_name, first_name, users.identifier
     from users
    where users.identifier=$owner_id"));

site_header($album_name);

$user_display_string = user_disp_string($owner_id, $po_user['id'], 
					$user_data[0], $user_data[1]);

if ($po_user['id'] == $owner_id) {
  site_navigator(5);
} else {
  site_navigator(1);
}

$num_of_photos_a = pg_fetch_row(pg_query($database, "
   select count(photo.identifier) from album, album_content, photo
    where album_content.photo = photo.identifier
      and album_content.album = album.identifier
      and album.identifier = $album_id
     $sql_query_access_rights_string"));
$num_of_photos = $num_of_photos_a[0];

if ($po_options['photo_view'] == "slide") {
  $limit = $po_options['photos_per_page'];
} else {
  $limit = $po_options['rows_list_view'];
}

/* Sanity checks */
if ($limit > $num_of_photos) {
  $limit = $num_of_photos;
}
while ($num_of_photos && $offset >= $num_of_photos) {
  $offset -= $limit;
}
if ($offset < 0) {
  $offset = 0;
}
if (($offset + $limit) > $num_of_photos) {
  $items = $num_of_photos - $offset;
} else {
  $items = $limit;
}

$path_to_album = get_path_to_album($database, $album_id);

if ($po_user['id'] == $owner_id) 
  $edit_album = "<a href=\"album.edit.php?album=$album_id\">$album[0]</a>";
 else
   $edit_album = "$album[0]";

if ($num_of_photos == 0) {
  site_navigator_status(emit_a("user.php", $strings['generic']['users']). " : $user_display_string $path_to_album : $edit_album", $strings['generic']['is_empty']);
 } else {
  site_navigator_status(emit_a("user.php", $strings['generic']['users']). " : $user_display_string $path_to_album : $edit_album", $strings['generic']['displaying'] . " " . display_photo_index_status($offset, $limit, $num_of_photos));
 }

if ($album[3]) {
  site_navigator_status($album[3], "");
 }

if ($album_id != $po_user['spool_album']) {
  display_albums($database, "$album_id", $album[2], $album[4], "with_header");
 }

if ($num_of_photos == 0) {
  site_footer($database);
  site_epilog($database);
  exit();
 }

$album_photo = pg_query($database,
  "select photo.identifier as identifier, 
          photo.caption as caption,
          date_of_exposure, 
          photo.date_added,
          photo.access_rights,
          11 - (select avg(rating.value) from rating where rating.photo = photo.identifier) as rating,
          views,
          photo.title as title, 
          photo.author as author,
          photo_version.original_image_name as original_image_name,
          photo.users as users,
          view_location.place, view_location.country, view_location.city, view_location.state,
          photo_version.identifier as version
     from album, album_content, photo, photo_version, view_location
    where photo_version.identifier = album_content.version
      and album_content.album = album.identifier
      and photo.identifier = photo_version.photo
      and album.users = $owner_id
      and album.identifier = $album_id
      and view_location.identifier = photo.location
      $sql_query_access_rights_string
    order by $sql_query_order_by_string
   offset $offset
    limit $limit");

print "<form  name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
print "<input type=\"hidden\" name=\"user\" value=\"$owner_id\"/>";
print "<input type=\"hidden\" name=\"return\" value=\"album.php?album=$album_id&amp;offset=$offset\"/>";
print "<input type=\"hidden\" name=\"photo_view\" value=\"$po_options[photo_view]\"/>";
print "<input type=\"hidden\" name=\"source_album\" value=\"$album_id\"/>";

display_photo_navigator("album.php?album=$album_id", $offset, $limit, $num_of_photos);
if ($po_options['photo_view'] == "slide") {
  display_photo_slides("album", $album_id, $album_photo, 0, $items, true, true);
} else {
  display_photo_list("album", $album_id, $album_photo, 0, $items);
}
display_photo_navigator("album.php?album=$album_id", $offset, $limit, $num_of_photos);

site_navigator_status(emit_a("user.php", $strings['generic']['users']). " : $user_display_string $path_to_album : $album[0]",  $strings['generic']['displaying'] . " " . display_photo_index_status($offset, $limit, $num_of_photos));

print "<div class=\"actions\">";

display_order_by_combo_with_button($order_by);

if ($po_options['photo_view'] == 'slide') {
  display_photos_per_page_combo('photos_per_page', $po_options['photos_per_page']);
 } else {
  display_photos_per_page_combo('rows_list_view', $po_options['rows_list_view']);
 }

print "<table><tr><td>\n";

display_list_slide_option($po_options['photo_view'], "album.php?album=$album_id&amp;offset=$offset");

if ($po_user['type'] >= PO_USER_TYPE_CLIENT) {
  display_selectbutton();
  if ($album_id != $po_user['spool_album']) {
    print $thm_elem['button.add.to.spool'];
  }
 }

if (($po_user['id'] == $owner_id) || 
    ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
  print $thm_elem['button.bulk.update'];

  print $thm_elem['button.delete_s'];
 }

print "</td></tr></table>";

if (($po_user['id'] == $owner_id) || 
    ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
  $album_all = pg_query($database, "
     select identifier, caption, parent_album
       from album
      where users=$owner_id
        and caption != 'Spool'
      order by date_of_creation desc");
    $folder_all = pg_query($database, "select identifier, caption, parent_folder from folder where users=$owner_id and caption != 'Trash' order by date_of_creation desc");
    display_folder_actions($folder_all, "");
    if (pg_num_rows($album_all) > 0) {
      display_album_actions($album_all, $album_id);
    }
 }

if ($po_user['type'] >= PO_USER_TYPE_CLIENT) {
  display_spool_actions($database, $po_user['id']);
 }

print "</div>";

print "</form>\n";

site_footer($database);
site_epilog($database);
?>
