<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/config.php";
;
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog(PO_USER_TYPE_USER);

$photo_id   = pg_escape_string($_REQUEST['photo']);
$version  = pg_escape_string($_REQUEST['ver']);

$photo_data = pg_fetch_row(pg_query($database, "
  select caption, get_image_path(photo_version.identifier, 2) as preview_path, users, title
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.identifier = $version
     and photo.identifier = '$photo_id'"));

/* Ensure mere users don't move/mangle a photo that isn't theirs! */
if ($photo_data[2] != $po_user['id'] && 
    $po_user['type'] < PO_USER_TYPE_ADMIN) {
  site_epilog($database);
  site_push_error($strings['errors']['not_owner']);
  header("Location: login.php");
  exit();
 }

$photo_original = pg_fetch_row(pg_query($database, "select storage_location, storage_index from photo_dupe where photo=$photo_id and key=1"));
$folder_data    = pg_fetch_row(pg_query($database, "select folder.identifier, folder.caption from photo, folder where photo.folder = folder.identifier and photo.identifier='$photo_id'"));
$user_data      = pg_fetch_row(pg_query($database, "select identifier, last_name, first_name from users where identifier=$photo_data[2]"));


site_header(sprintf($strings['profile']['add'], $strings['photo']['dupe']));

$user_display_string = user_disp_string($photo_data[2], $po_user['id'], 
					"", "");
site_navigator(5);

$path_to_folder = get_path_to_folder($database, $folder_data[0]);
$title = get_photo_title($photo_data[0], $photo_data[3]);
site_navigator_status("$user_display_string $path_to_folder : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : <a href=\"photo.php?photo=$photo_id\">$title</a> : ".sprintf($strings['profile']['add'], $strings['photo']['dupe']), "");

print "<center>\n";
display_shaded_photo("image.display.php?image=$photo_id&amp;size=2&amp;ver=$version", "", $image_repository_path . "/" . $photo_data[1]);
print "</center>\n";

print "<form method=\"post\" action=\"photo.dupe.add.2.php\">\n";
print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\" />\n";
print "<input type=\"hidden\" name=\"version\" value=\"$version\" />\n";
print "<table class=\"profile\">\n";
print "<tr>";
print emit_th($strings['import']['storage_location'], "colspan=\"2\" width=\"25%\"");
print emit_th($strings['generic']['created'], "width=\"25%\"");

print emit_th($strings['generic']['remark'], "width=\"50%\"");
print "</tr>";

print "<tr>";
print "<td><input type=\"text\" name=\"storage_location\" value=\"$photo_original[0]\" /></td><td><input type=\"text\" name=\"storage_index\" value=\"$photo_original[1]\" /></td>";
print "<td>\n";
print emit_date_input_form("creation_timestamp", "");
print "</td>\n";
print "<td><input type=\"text\" name=\"remark\" /></td>\n";
print "</tr>";

print "</table>\n";
print "<center>";
print $thm_elem['button.add.duplicate'];
print $thm_elem['button.cancel'];
print "</center>";
print "</form>\n";


site_footer($database);
site_epilog($database);
?>
