<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/config.php";
;
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog(PO_USER_TYPE_CLIENT);

$photo_id = pg_escape_string($_REQUEST['photo']);
$version  = pg_escape_string($_REQUEST['ver']);

$photo_data = pg_fetch_row(pg_query($database, "
  select users, caption, get_image_path(photo_version.identifier, 2) as preview_path, title, access_rights,
         can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}') as ok
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.identifier = $version
     and photo_version.photo = '$photo_id'"));
$folder_data = pg_fetch_row(pg_query($database, "
  select folder.identifier, folder.caption
    from photo, folder
   where photo.folder = folder.identifier
     and photo.identifier='$photo_id'"));
$user_name   = pg_fetch_row(pg_query($database, "
  select identifier, last_name, first_name
    from users
   where identifier=$photo_data[0]"));

$rating = pg_fetch_row(pg_query($database, "
  select value, identifier
    from rating
   where photo='$photo_id'
     and version='$version'
     and users='$po_user[id]'"));

$owner_id = $photo_data[0];

if ($photo_data[5] != 't') {
  if ($photo_data[4] == $access['private']) {
    header("HTTP/1.1 403 Forbidden");
    site_header($strings['generic']['display_folder']);
    site_navigator(1);
    site_navigator_status(user_disp_string(0, $po_user['id'], "", ""). " : ". $strings['errors']['private'], "");
    site_footer($database);
    site_epilog($database);
  } else {
    site_push_error($strings['errors']['protected']);
    header("Location: login.php?reason=protected&orig=".urlencode("photo.php?photo=$photo_id&ver=$version"));
  }
 }

site_header(sprintf($strings['profile']['add'], $strings['generic']['rating']));

$user_display_string = user_disp_string($photo_data[0], $po_user['id'], 
					$user_name[1], $user_name[2]);
if ($po_user['id'] == $photo_data[0]) {
  site_navigator(5);
 } else {
  site_navigator(1);
 }

$path_to_folder = get_path_to_folder($database, $folder_data[0]);
$title = get_photo_title($photo_data[1], $photo_data[3]);
site_navigator_status("$user_display_string $path_to_folder : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : <a href=\"photo.php?photo=$photo_id&amp;ver=$version\">$title</a> : ".sprintf($strings['profile']['add'], $strings['generic']['rating']), "");

print "<center>\n";
display_shaded_photo("image.display.php?image=$photo_id&size=2&ver=$version", "", $image_repository_path . "/" . $photo_data[2]);
print "</center>\n";

if ($rating[0]) {
  print "<div align=\"center\">";
  print err_str($strings['errors']['already_rated']);
  print "<p>";
  print sprintf ($strings['photo']['rating_text'], $rating[0], 
		 emit_a("photo.rating.edit.php?rating=$rating[1]", $strings['generic']['modify']), 
		 emit_a("photo.rating.del.php?rating=$rating[1]", $strings['generic']['delete']));
  print "</p>";
  print $thm_elem['button.back'];
} else {
  print "<form method=\"post\" action=\"photo.rating.add.2.php\">\n";
  print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\"/>\n";
  print "<input type=\"hidden\" name=\"version\" value=\"$version\"/>\n";
  print "<table class=\"profile\">\n";
  print "<tr>";
  print emit_th($strings['photo']['rating'], "width=\"12%\"");
  print emit_th($strings['generic']['remark'], "width=\"88%\"");
  print "</tr><tr>";
  print "<td>";
  print "<select name=\"new_rating\">";
  for ($i=1; $i <= 10; $i++) {
    print emit_option($i, $i, FALSE);
  }
  print "</select>";
  print "</td>";
  print "<td><textarea name=\"comment\" rows=\"5\" cols=\"60\"></textarea></td>";
  print "</tr>";
  print "</table>\n";
  print $thm_elem['button.submit'];
  print $thm_elem['button.cancel'];
  print "</form>\n";
}

site_footer($database);
site_epilog($database);
?>
