<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/config.php";
;
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog(PO_USER_TYPE_CLIENT);

$rating_id   = pg_escape_string($_REQUEST['rating']);

$rating = pg_fetch_row(pg_query($database, "
  select value, users, photo, version
    from rating
   where identifier='$rating_id'"));

$photo_id = $rating[2];
$version = $rating[3];

/* Enforce ownership */
if (($po_user['type'] != PO_USER_TYPE_ADMIN) &&
    ($po_user['id'] != $rating[1])) {
  site_epilog($database);
  site_push_error($strings['errors']['not_owner']);
  header("Location: login.php");
  exit();
}

$photo_data  = pg_fetch_row(pg_query($database, "
  select users, caption, get_image_path(photo_version.identifier, 2) as preview_path, title
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.identifier = $rating[3]
     and photo_version.photo = $rating[2]"));
$folder_data = pg_fetch_row(pg_query($database, "
  select folder.identifier, folder.caption
    from photo, folder
   where photo.folder = folder.identifier
     and photo.identifier='$photo_id'"));
$user_name   = pg_fetch_row(pg_query($database, "
  select identifier, last_name, first_name
    from users
   where identifier=$photo_data[0]"));

site_header(sprintf($strings['profile']['delete'], $strings['generic']['rating']));

$user_display_string = user_disp_string($photo_data[0], $po_user['id'], 
					$user_name[1], $user_name[2]);
if ($po_user['id'] == $photo_data[0]) {
  site_navigator(5);
 } else {
  site_navigator(1);
 }

$path_to_folder = get_path_to_folder($database, $folder_data[0]);
$title = get_photo_title($photo_data[1], $photo_data[3]);
site_navigator_status("$user_display_string $path_to_folder : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : <a href=\"photo.php?photo=$photo_id&amp;ver=$version\">$title</a> : ".sprintf($strings['profile']['delete'], $strings['generic']['rating']), "");

print "<center>\n";
display_shaded_photo("image.display.php?image=$photo_id&size=2&ver=$version", "", $image_repository_path . "/" . $photo_data[2]);
print "<form method=\"post\" action=\"photo.rating.del.2.php\">\n";
print "<input type=\"hidden\" name=\"rating\" value=\"$rating_id\"/>\n";
print "<p>";
print sprintf ($strings['photo']['rating_text'], $rating[0], 
	       emit_a("photo.rating.edit.php?rating=$rating[1]", $strings['generic']['modify']), 
	       emit_a("photo.rating.del.php?rating=$rating[1]", $strings['generic']['delete']));
print "</p>";
print $thm_elem['button.confirm.delete'];
print $thm_elem['button.cancel'];
print "</form>\n";
print "</center>\n";


site_footer($database);
site_epilog($database);
?>
