<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/stemming.php";
include_once "include/search.php";
;

function display_search_operator($item_name, $value) {
  global $strings;

  print "<select name=\"$item_name\">\n";
  print emit_option("or", $strings['search']['union'], $value == "or");
  print emit_option("and", $strings['search']['intersect'], $value == "and");
  print "</select>\n";
}

function display_advanced_search_entry($database, $search_data, $search_operator) {
  global $thm_elem;
  global $strings;
  global $search_interface;

  display_navigator_box_top($search_interface['text_advanced']['idx'], $search_interface, "100%");

  print "<table class=\"search\">";
  print "<tr><td  align=\"left\"  colspan=\"2\">";

  print "<table class=\"listing\">";

  print "<tr><td align=\"right\">".$strings['photo']['identifier']."</td><td >";
  print "<input type=\"text\" name=\"identifier\" value=\"".$search_data['identifier']."\" size=\"50\" /></td><td>";
  display_search_operator("identifier_operator", $search_operator['identifier']);
  print "</td></tr>";

  print "<tr><td align=\"right\">".$strings['generic']['title']."</td><td >";
  print "<input type=\"text\" name=\"title\" value=\"".$search_data['title']."\" size=\"50\" /></td><td>";
  display_search_operator("title_operator", $search_operator['title']);
  print "</td></tr>";

  print "<tr><td align=\"right\">".$strings['generic']['author']."</td><td >";
  print "<input type=\"text\" name=\"author\" value=\"".$search_data['author']."\" size=\"50\" /></td><td>";
  display_search_operator("author_operator", $search_operator['author']);
  print "</td></tr>";

  print "<tr><td align=\"right\">".$strings['generic']['keywords']."</td><td >";
  print "<input type=\"text\" name=\"keyword\" value=\"".$search_data['keyword']."\" size=\"50\" /></td><td>";
  display_search_operator("keyword_operator", $search_operator['keyword']);
  print "</td></tr>";

  print "<tr><td align=\"right\">".$strings['generic']['caption']."</td><td >";
  print "<input type=\"text\" name=\"caption\" value=\"".$search_data['caption']."\" size=\"50\" /></td><td>";
  display_search_operator("caption_operator", $search_operator['caption']);
  print "</td></tr>";

  print "<tr><td align=\"right\">".$strings['generic']['location']."</td><td >";
  print "<input type=\"text\" name=\"location\" value=\"".$search_data['location']."\" size=\"50\" /></td><td>";
  display_search_operator("location_operator", $search_operator['location']);
  print "</td></tr>";
  print "</table>";

  print "</td></tr>";
  print "<tr><td align=\"center\"   colspan=\"2\">";
  print $thm_elem['button.search'];
  print $thm_elem['button.clear'];
  print "</td></tr>";
  print "</table>";
  
  display_navigator_box_bottom("100%");
}

$folder_id = "";
$album_id = "";

$search_data['identifier'] = validate_search_string($_REQUEST['identifier']);
$search_data['title']      = validate_search_string($_REQUEST['title']);
$search_data['author']     = validate_search_string($_REQUEST['author']);
$search_data['keyword']    = validate_search_string($_REQUEST['keyword']);
$search_data['caption']    = validate_search_string($_REQUEST['caption']);
$search_data['location']   = validate_search_string($_REQUEST['location']);

$search_operator['identifier'] = $_REQUEST['identifier_operator'];
$search_operator['title']      = $_REQUEST['title_operator'];
$search_operator['author']     = $_REQUEST['author_operator'];
$search_operator['keyword']    = $_REQUEST['keyword_operator'];
$search_operator['caption']    = $_REQUEST['caption_operator'];
$search_operator['location']   = $_REQUEST['location_operator'];

$offset = pg_escape_string(isset($_REQUEST['offset']) ? $_REQUEST['offset'] : 0);

$order_by = $po_options['order_by'];
$ignored_keywords = "";

$database      = site_prolog();

$sql_query_order_by_string = $order_by_string[$order_by][0];

site_header($strings['generic']['search']);
site_navigator(2);

$keywords['identifier'] = extract_keywords($search_data['identifier'], $po_options['search_enable_stemming'], 0);
$keywords['title']      = extract_keywords($search_data['title'], $po_options['search_enable_stemming'], 0);
$keywords['author']     = extract_keywords($search_data['author'], $po_options['search_enable_stemming'], 0);
$keywords['keyword']    = extract_keywords($search_data['keyword'], $po_options['search_enable_stemming'], 0);
$keywords['caption']    = extract_keywords($search_data['caption'], $po_options['search_enable_stemming'], 0);
$keywords['location']   = extract_keywords($search_data['location'], $po_options['search_enable_stemming'], 0);

if (!$search_data['identifier'] &&
    !$search_data['title'] &&
    !$search_data['author'] &&
    !$search_data['keyword'] &&
    !$search_data['caption'] &&
    !$search_data['location']) {
  site_navigator_status($strings['search']['string'], "");
  print "<form action=\"search.text.advanced.php\" method=\"post\">";
  display_advanced_search_entry($database, $search_data, $search_operator);
  print "</form>";
  if ($ignored_keywords != "") {
    print "<div align=\"center\" >\n";
    print $strings['search']['ignore_keywords']." $ignored_keywords<br/>";
    print $strings['search']['use_quotes'];
    print "</div>\n";
  }
  site_footer($database);
  site_epilog($database);
  exit();
}

$status_string=$strings['search']['displaying'];

$sql_search_string['identifier'] = build_sql_search_string($keywords['identifier'], "photo.identifier");
$sql_search_string['title']      = build_sql_search_string($keywords['title'],      "photo.title");
$sql_search_string['author']     = build_sql_search_string($keywords['author'],     "photo.author");
if ($keywords['keyword'] != "") {
  $sql_search_string['keyword']  = build_sql_search_string_keywords($keywords['keyword']);
 }
$sql_search_string['caption']    = build_sql_search_string($keywords['caption'],    "photo.caption");
$sql_search_string['location']   = build_sql_search_string($keywords['location'],   "(view_location.place|||view_location.city|||view_location.state|||view_location.country)");

$sql_combined_search_string = "";

if ($sql_search_string['identifier'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['identifier']." " .$sql_search_string['identifier'];
  else
    $sql_combined_search_string = $sql_search_string['identifier'];
}

if ($sql_search_string['title'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['title']." " .$sql_search_string['title'];
  else
    $sql_combined_search_string = $sql_search_string['title'];
}

if ($sql_search_string['author'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['author']." " .$sql_search_string['author'];
  else
    $sql_combined_search_string = $sql_search_string['author'];
}

if ($sql_search_string['keyword'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['keyword']." " .$sql_search_string['keyword'];
  else
    $sql_combined_search_string = $sql_search_string['keyword'];
}

if ($sql_search_string['caption'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['caption']." " .$sql_search_string['caption'];
  else
    $sql_combined_search_string = $sql_search_string['caption'];
}

if ($sql_search_string['location'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['location']." " .$sql_search_string['location'];
  else
    $sql_combined_search_string = $sql_search_string['location'];
}

/* this is just to avoid having three separate queries */
if ($sql_combined_search_string == "") {
  $sql_combined_search_string = "photo.identifier=null";
}

$sql_query_access_rights_string = " can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}')";

if (!$offset) {
  $offset = 0;
}

if ($po_options['photo_view'] == "slide") {
  $limit = $po_options['photos_per_page'];
 } else {
  $limit = $po_options['rows_list_view'];
 }

$query_string = 
        "select photo.identifier, photo.caption, photo.date_of_exposure, photo.date_added,
                 photo.access_rights,
                 11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
                 views,
                 photo.title, photo.author,
                 photo_version.original_image_name, photo.users,
                 view_location.place, view_location.country, view_location.city, view_location.state,
                 photo_version.identifier as version
            from photo, folder, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
             and photo.identifier = photo_version.photo
             and photo.location = view_location.identifier
             and ($sql_combined_search_string)
             and $sql_query_access_rights_string
           order by $sql_query_order_by_string";

// print "<pre> $query_string </pre>";

$search_result = pg_query($database,$query_string);
$num_of_matches = pg_num_rows($search_result);

/* Sanity checks */
if ($limit > $num_of_matches) {
  $limit = $num_of_matches;
 }
while ($num_of_matches && $offset >= $num_of_matches) {
  $offset -= $limit;
 }
if ($offset < 0) {
  $offset = 0;
 }
if (($offset + $limit) > $num_of_matches) {
  $items = $num_of_matches - $offset;
 } else {
  $items = $limit;
 }

if ($num_of_matches == 0) {
  $itemized_search_string['identifier'] = build_itemized_search_string($search_data['identifier'], "identifier", "");
  $itemized_search_string['title']      = build_itemized_search_string($search_data['title'],      "title",      "");
  $itemized_search_string['author']     = build_itemized_search_string($search_data['author'],     "author",     "");
  $itemized_search_string['keyword']    = build_itemized_search_string($search_data['keyword'],    "keyword",    "");
  $itemized_search_string['caption']    = build_itemized_search_string($search_data['caption'],    "caption",    "");
  $itemized_search_string['location']   = build_itemized_search_string($search_data['location'],   "location",   "");

  site_navigator_status($strings['search']['no_matches']." $itemized_search_string", "");
  print "<form action=\"search.text.advanced.php\" method=\"post\">";
  display_advanced_search_entry($database, $search_data, $search_operator);
  print "</form>";
  if ($ignored_keywords != "") {
    print "<center>\n";
    print $strings['search']['ignore_keywords']." $ignored_keywords<br/>";
    print $strings['search']['use_quotes'];
    print "</center>\n";
  }
  site_footer($database);
  site_epilog($database);
  exit();
}

$itemized_search_string['identifier'] = build_itemized_search_string($search_data['identifier'], "identifier", "");
$itemized_search_string['title']      = build_itemized_search_string($search_data['title'],      "title",      "");
$itemized_search_string['author']     = build_itemized_search_string($search_data['author'],     "author",     "");
$itemized_search_string['keyword']    = build_itemized_search_string($search_data['keyword'],    "keyword",    "");
$itemized_search_string['caption']    = build_itemized_search_string($search_data['caption'],    "caption",    "");
$itemized_search_string['location']   = build_itemized_search_string($search_data['location'],   "location",   "");

site_navigator_status($strings['search']['searched_for']." $itemized_search_string",  $strings['search']['displaying'] ." ". display_photo_index_status($offset, $limit, $num_of_matches));
print "<form action=\"search.text.advanced.php\" method=\"post\">";
display_advanced_search_entry($database, $search_data, $search_operator);
print "</form>";
if ($ignored_keywords != "") {
  print "<center>\n";
  print $strings['search']['ignore_keywords']." $ignored_keywords<br/>";
  print $strings['search']['use_quotes'];
  print "</center>\n";
}
print "&nbsp;<br/>\n";


$arguments = "&amp;offset=$offset";

$search_string =
"identifier=".$search_data['identifier'].
"&amp;title=".$search_data['title'].
"&amp;author=".$search_data['author'].
"&amp;keyword=".$search_data['keyword'].
"&amp;caption=".$search_data['caption'].
"&amp;location=".$search_data['location'].
"&amp;dentifier_operator=".$search_operator['identifier'].
"&amp;title_operator=".$search_operator['title'].
"&amp;author_operator=".$search_operator['author'].
"&amp;keyword_operator=".$search_operator['keyword'].
"&amp;caption_operator=".$search_operator['caption'].
"&amp;location_operator=".$search_operator['location'];

$search_string_exp = str_replace(" ", "+", $search_string);

print "<form  name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
print "<input type=\"hidden\" name=\"return\" value=\"search.text.advanced.php?$search_string$arguments\"/>";

display_photo_navigator("search.text.advanced.php?search_string=$search_string_exp$arguments", $offset, $limit, $num_of_matches);

if ($po_options['photo_view'] == "slide") {
  $checkboxes = display_photo_slides("search_advanced", $folder_id, $search_result, $offset, $items, true, true); 
 } else {
  $checkboxes = display_photo_list("search_advanced", $folder_id, $search_result, $offset, $items);
 }
display_photo_navigator("search.text.advanced.php?search_string=$search_string_exp$arguments", $offset, $limit, $num_of_matches);

print "&nbsp;<br/>\n";

$itemized_search_string['identifier'] = build_itemized_search_string($search_data['identifier'], "identifier", "");
$itemized_search_string['title']      = build_itemized_search_string($search_data['title'],      "title",      "");
$itemized_search_string['author']     = build_itemized_search_string($search_data['author'],     "author",     "");
$itemized_search_string['keyword']    = build_itemized_search_string($search_data['keyword'],    "keyword",    "");
$itemized_search_string['caption']    = build_itemized_search_string($search_data['caption'],    "caption",    "");
$itemized_search_string['location']   = build_itemized_search_string($search_data['location'],   "location",   "");

site_navigator_status("Searched database for $itemized_search_string",  $strings['search']['displaying'] . display_photo_index_status($offset, $limit, $num_of_matches));

print "<div class=\"actions\">";

display_order_by_combo_with_button($order_by);

if ($po_options['photo_view'] == 'slide') {
  display_photos_per_page_combo('photos_per_page', $po_options['photos_per_page']);
 } else {
  display_photos_per_page_combo('rows_list_view', $po_options['rows_list_view']);
 }

print "<table><tr><td>\n";

display_list_slide_option($po_options['photo_view'], "search.text.advanced.php?$search_string$arguments");

if ($checkboxes > 0 && $po_user['id']) {
  display_selectbutton();
  print $thm_elem['button.add.to.spool'];
  print $thm_elem['button.bulk.update'];
 } 

print "</td></tr></table>\n";

if ($checkboxes > 0 && $po_user['id']) {
  $folder_all = pg_query($database, "select identifier, caption, parent_folder from folder where users=$po_user[id] and caption != 'Trash' order by date_of_creation desc");
  display_folder_actions($folder_all, $folder_id);

  $album_all = pg_query($database, "select identifier, caption, parent_album from album where users=$po_user[id] and caption != 'Spool' order by date_of_creation desc");
  if (pg_num_rows($album_all) > 0) {
    display_album_actions($album_all, $album_id);
  }
}

if ($po_user['id']) {
  display_spool_actions($database, $po_user['id']);
 }

print "</div>";

print "</form>";

print "&nbsp;<br/>\n";

site_footer($database);
site_epilog($database);
?>
