<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/search.php";
;

function display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id) {
  global $thm_elem;
  global $search_interface;
  global $site_url;
  global $strings;

  display_navigator_box_top($search_interface['text_general']['idx'], $search_interface, "100%");

  print "<table class=\"search\">";
  print "<tr><td align=\"center\">";
  print "<input type=\"text\" name=\"search_string\" value=\"$search_string\" size=\"50\"/>";
  print "</td><td >";

  print "<select onchange=\"location = this.options[this.selectedIndex].value;\">\n";
  for ($i = 0; $i < 3; $i++)
    print emit_option("search.text.general.php?search_type=$i", $search_type_string[$i], $search_type == $i);
  print "</select>";
  print "<input type=\"hidden\" name=\"search_type\" value=\"$search_type\"/>";

  print "</td>";

  if ($search_type_string[$search_type] != "Users") {
    print "<td >";
    print generate_html_users_combo("current_user", $database, $current_user_id, TRUE, FALSE);
    print "</td>";
    $colspan = 3;
  } else {
    $colspan = 2;
  }

  print "</tr>";
  print "<tr><td align=\"center\" colspan=\"$colspan\">";
  print $thm_elem['button.search'];
  print "</td></tr>";
  print "</table>";

  display_navigator_box_bottom("100%");
}

$folder_id = "";
$album_id = "";

$search_type    = isset($_REQUEST['search_type']) ? $_REQUEST['search_type'] : 0;

$search_string  = isset($_REQUEST['search_string']) ? $_REQUEST['search_string'] : "";

$search_string  = validate_search_string($search_string);
$current_user_id = isset($_REQUEST['current_user']) ? $_REQUEST['current_user'] : 0;

if (!$current_user_id || ($current_user_id=="all")) {
  $current_user_id = "null";
  $sql_photo_users_string = " ";
  $sql_folder_users_string = " ";
  $sql_album_users_string = " ";
} else {
  $sql_photo_users_string = " and photo.users = $current_user_id ";
  $sql_folder_users_string = " and folder.users = $current_user_id ";
  $sql_album_users_string = " and album.users = $current_user_id ";
}

$offset = pg_escape_string(isset($_REQUEST['offset']) ? $_REQUEST['offset'] : 0);

$order_by = $po_options['order_by'];
$ignored_keywords = "";

$database      = site_prolog();

$sql_query_order_by_string = $order_by_string[$order_by][0];

site_header($strings['generic']['search']);

site_navigator(2);

$keywords = extract_keywords($search_string, $po_options['search_enable_stemming'], $search_type);

if (!$keywords) {
  site_navigator_status($strings['search']['string'], "");
  print "<form action=\"search.text.general.php\" method=\"post\">";
  display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
  print "</form>";
  if ($ignored_keywords != "") {
    print "&nbsp;<br/>\n";
    print "<div align=\"center\">\n";
    print $strings['search']['ignore_keywords']." $ignored_keywords<br/>";
    print $strings['search']['use_quotes'];
    print "</div>\n";
  }
  print "&nbsp;<br/>\n";

  site_footer($database);
  site_epilog($database);
  exit();
}

$num_of_matches = 0;

if ($po_options['photo_view'] == "slide") {
  $limit = $po_options['photos_per_page'];
 } else {
  $limit = $po_options['rows_list_view'];
 }

switch ($search_type) {
 default:
 case 0: /* photo search */
   $status_string=$strings['search']['displaying'];

   $entries = array();
   $cols = array('photo.identifier', 
		 'photo.title',
		 'photo.author',
		 'photo.comments',
		 'photo.caption',
		 'view_location.place',
		 'view_location.city',
		 'view_location.state',
		 'view_location.country',
		 'photo_version.original_image_name');

   foreach ($cols as $col) {
     $entries[] = build_sql_search_string($keywords, $col);
   }
   $entries[] = build_sql_search_string_keywords($keywords);

   $sql_search_combined = implode(" OR ", $entries);

   $sql_query_access_rights_string = " can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}')";

  $search_query = "
         select photo.identifier, photo.caption, photo.date_of_exposure, photo.date_added,
                 photo.access_rights,
                 11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
                 views,
                 photo.title, photo.author, 
                 photo_version.original_image_name, photo.users,
                 view_location.place, view_location.country, view_location.city, view_location.state,
                 photo_version.identifier as version
            from photo, folder, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.location = view_location.identifier
             and ($sql_search_combined)
             and $sql_query_access_rights_string
           order by $sql_query_order_by_string";
    // print "<pre>$search_query</pre>";
    $search_result = pg_query($search_query);
    $num_of_matches = pg_num_rows($search_result);

    /* Sanity checks */
    if ($limit > $num_of_matches) {
      $limit = $num_of_matches;
    }
    while ($num_of_matches && $offset >= $num_of_matches) {
      $offset -= $limit;
    }
    if ($offset < 0) {
      $offset = 0;
    }
    if (($offset + $limit) > $num_of_matches) {
      $items = $num_of_matches - $offset;
    } else {
      $items = $limit;
    }
    
   break;
 case 1: /* folder search */
   $status_string = $strings['search']['albums_found'];
   $sql_search_string = build_sql_search_string($keywords, "folder.caption");
   $sql_search_string .= " OR " . build_sql_search_string($keywords, "folder.description");

   $sql_query_access_rights_string = "can_access_folder(folder.identifier, $po_user[id], '{".$passwords."}')"; 

   $search_result_f = pg_query($database,
        "select caption, folder.identifier as folder_id, date_of_creation,
                first_name, last_name, users.identifier as user_id, 
                count_subfolders_by_folder(folder.identifier, $po_user[id], '{".$passwords."}') as subs,
                count_photos_by_folder(folder.identifier, $po_user[id], '{".$passwords."}') as photos
           from folder, users
          where ($sql_search_string)
                $sql_folder_users_string
            and $sql_query_access_rights_string
            and users.identifier = folder.users
          order by caption");

   $sql_search_string = build_sql_search_string($keywords, "album.caption");
   $sql_search_string .= " OR " . build_sql_search_string($keywords, "album.description");

   $sql_query_access_rights_string = "can_access_album(album.identifier, $po_user[id], '{".$passwords."}')"; 

   $search_result_a = pg_query($database,
        "select caption, album.identifier as album_id, date_of_creation,
                first_name, last_name, users.identifier as user_id,
                count_subalbums_by_album(album.identifier, $po_user[id], '{".$passwords."}') as subs, 
                count_photos_by_album(album.identifier, $po_user[id], '{".$passwords."}') as photos
           from album, users
          where ($sql_search_string)
                $sql_album_users_string
            and $sql_query_access_rights_string
            and users.identifier = album.users
          order by caption");

   $num_of_matches  = pg_num_rows($search_result_f);
   $num_of_matches += pg_num_rows($search_result_a);

   break;
 case 2: /* user search */
   $status_string = $strings['search']['display_users'];

   $sql_search_string = "(".
     build_sql_search_string($keywords, "last_name")." OR ".
     build_sql_search_string($keywords, "first_name")." OR ".
     build_sql_search_string($keywords, "username").")";

   $search_result = pg_query($database,
         "select identifier, first_name, last_name, member_since, type, hide
            from users
           where ($sql_search_string)
             and type > ".PO_USER_TYPE_CLIENT."
           order by last_name, first_name");
   $num_of_matches = pg_num_rows($search_result);
}

if ($num_of_matches == 0) {
  $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&amp;");
  site_navigator_status($strings['search']['no_matches']." $itemized_search_string", "");

  print "<form action=\"search.text.general.php\" method=\"post\">";
  display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
  print "</form>";
  if ($ignored_keywords != "") {
    print "<center>\n";
    print $strings['search']['ignore_keywords']." $ignored_keywords<br/>";
    print $strings['search']['use_quotes'];
    print "</center>\n";
  }

  site_footer($database);
  site_epilog($database);
  exit();
}

$itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&amp;");
site_navigator_status($strings['search']['searched_for']." $itemized_search_string",  $status_string. " " . display_photo_index_status($offset, $limit, $num_of_matches));
print "<form action=\"search.text.general.php\" method=\"post\">";
display_general_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
print "</form>";
if ($ignored_keywords != "") {
  print "&nbsp;<br/>\n";
  print "<center>\n";
  print $strings['search']['ignore_keywords']." $ignored_keywords<br/>";
  print $strings['search']['use_quotes'];
  print "</center>\n";
}

switch ($search_type) {
 default:
 case 0: /* photo search */
   $arguments = "&amp;search_type=$search_type";

   $search_string_exp = str_replace(" ", "+", $search_string);

   print "<form  name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
   print "<input type=\"hidden\" name=\"return\" value=\"search.text.general.php?search_string=$search_string$arguments\"/>";
   
   display_photo_navigator("search.text.general.php?search_string=$search_string_exp$arguments", $offset, $limit, $num_of_matches);

   if ($po_options['photo_view'] == "slide") {
     $checkboxes = display_photo_slides("search_general", $folder_id, $search_result, $offset, $items, true, true);
   } else {
     $checkboxes = display_photo_list("search_general", $folder_id, $search_result, $offset, $items);
   }
   
   display_photo_navigator("search.text.general.php?search_string=$search_string_exp$arguments", $offset, $limit, $num_of_matches);

   $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&amp;");
   site_navigator_status($strings['search']['searched_for'] ."$itemized_search_string",  $status_string ." " . display_photo_index_status($offset, $limit, $num_of_matches));

   print "<div class=\"actions\">";
   display_order_by_combo_with_button($order_by);

   if ($po_options['photo_view'] == 'slide') {
     display_photos_per_page_combo('photos_per_page', $po_options['photos_per_page']);
   } else {
     display_photos_per_page_combo('rows_list_view', $po_options['rows_list_view']);
   }

   print "<table><tr><td>\n";

   display_list_slide_option($po_options['photo_view'], "search.text.general.php?search_type=$_REQUEST[search_type]&amp;search_string=$_REQUEST[search_string]&amp;offset=$offset");
   
   if ($checkboxes > 0 && $po_user['id']) {
     display_selectbutton();
     print $thm_elem['button.add.to.spool'];
     print $thm_elem['button.bulk.update'];
   }

   print "</td></tr></table>\n";

if ($checkboxes > 0 && $po_user['id']) {
     $folder_all = pg_query($database, "select identifier, caption, parent_folder from folder where users=$po_user[id] and caption != 'Trash' order by date_of_creation desc");
     display_folder_actions($folder_all, $folder_id);
     
     $album_all = pg_query($database, "select identifier, caption, parent_album from album where users=$po_user[id] and caption != 'Spool' order by date_of_creation desc");
     if (pg_num_rows($album_all) > 0) {
       display_album_actions($album_all, $album_id);
     }
     
   }
   if ($po_user['id']) {
     display_spool_actions($database, $po_user['id']);
   }

   print "</div>";
   print "</form>";

   break;
 case 1: /* folder search */
   if (pg_num_rows($search_result_f) > 0)
     display_folder_with_users($database, $po_user['id'], $search_result_f);
   if (pg_num_rows($search_result_a) > 0)
     display_album_with_users($database, $po_user['id'], $search_result_a);

   $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&amp;");

   site_navigator_status($strings['search']['searched_for'] ." $itemized_search_string",  $status_string ." " . display_photo_index_status($offset, 0, $num_of_matches));
   break;
 case 2: /* user search */
   display_users($database, $search_result, "");
   $itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&amp;");
   site_navigator_status($strings['search']['searched_for'] ." $itemized_search_string",  $status_string ." " . display_photo_index_status($offset, 0, $num_of_matches));
}

site_footer($database);
site_epilog($database);
?>
